try {var geckotip = Components.classes["@geckotip.mozdev.org/geckotip/fx18;1"].getService(Components.interfaces.iGeckotip);} 
catch(err) { alert(document.getElementById("bundle_geckotip").getString(errmsg) + err); }

var tipPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService);
var tipPref = tipPrefService.getBranch("geckotip.");
const nsISupportsString = Components.interfaces.nsISupportsString;
var tipScopeOn = tipPref.getBoolPref("scopingon");
var tipLastDesc, tipCurrentScopes;


function getUnicodePref(prefName,prefBranch) {
    try { return prefBranch.getComplexValue(prefName, nsISupportsString).data; } catch(err) { return ""; }
}
function setUnicodePref(prefName,prefValue,prefBranch) {
    var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(nsISupportsString);
    sString.data = prefValue;
    prefBranch.setComplexValue(prefName,nsISupportsString,sString);
}

function tipBlur()
{
	document.getElementById("geckotip-panel-label").value = (tipScopeOn?"":"(") + "None" + (tipScopeOn?"":")");
	document.getElementById("tip-guess-menuitem").setAttribute("disabled","true");
	geckotip.unfocused();
}

function tipDebugPrint()
{
	alert("Scopes: " + tipCurrentScopes + "\nDescriptor: " + tipLastDesc);
}

function tipToggleInk()
{	
	tipScopeOn = !tipScopeOn;
	try { document.commandDispatcher.focusedElement.blur(); } catch(e) { }
	tipBlur();
}

function tipGetKey(fe)
{
	if (fe==null) return "";
	var tn = fe.tagName;
	if (!((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT"))) return "";
	var desc=tipElementDescriptor(fe);
	if ((desc=="{}")||(desc=="")) return ""; 
	if (fe.ownerDocument.location.hostname=="") return "";
	return fe.ownerDocument.location.hostname + ":" + desc;
}

function tipSetRecog(s) 
{
	var fe = document.commandDispatcher.focusedElement;
	feKey = tipGetKey(fe); 
	if (feKey=="") return false;
	if (s>=0) {
		tipSetScope(s,false); 
		setUnicodePref("scope." + feKey, s, tipPref);
	}
	else {
		tipSetScope(IS_DEFAULT,false);
		tipPref.clearUserPref("scope." + feKey);
	}
	fe.blur();
	fe.focus();
	return true;
}

function tipElementDescriptor(e)
{
	var gotID=false, gotName=false, desc="";

	while ( (e.getAttribute) && ((!gotID)||(!gotName)) )
	{
		if ((!gotID)&&(e.getAttribute("id"))) {
			gotID = true;
			desc=desc + "i[" + e.getAttribute("id") + "]l[" + label_for(e.getAttribute("id")) + "]";			
		}
		if ((!gotName)&&(e.getAttribute("name"))) {
			gotName = true;
			desc=desc + "n[" + e.getAttribute("name") + "]";			
		}
		try { e=e.parentNode; } catch(e) { desc="{"+desc+"}"; return desc.toLowerCase(); }
	}
	desc="{"+desc+"}"; 
	return desc.toLowerCase(); 
}

function label_for(id)
{
	var labels = document.getElementsByTagName("label");
	for (var i=0;i<labels.length;i++) 
		if (labels[i].htmlFor) 		
			if (labels[i].htmlFor==id)  return labels[i].textContent;
	return "";
}

function tipFocusedOnItem()
{
	var fw = document.commandDispatcher.focusedWindow;
	if (fw) {
		if (fw.document) {
			// editor mode in firefox, e.g. Gmail HTML email editor
			if (fw.document.designMode=="on") return true;
		}
		// thunderbird composition
		if (fw.name=="browser.message.body") return true;
	}
	var fe = document.commandDispatcher.focusedElement;
	if (fe==null) return false;
	var tn = fe.tagName;
	if ((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT")) return true;
	return false;
}

function tipFocus()
{
	geckotip.focused();
	tipLastDesc = "N/A"; //debug
	if (!tipFocusedOnItem()) { tipBlur(); return; }

	var fe = document.commandDispatcher.focusedElement;
	var feKey = tipGetKey(fe);
	if (feKey != "") {
		var s = getUnicodePref("scope." + feKey, tipPref);
		if (s != "") {						
			tipSetScope(1*s,false);
			document.getElementById("tip-guess-menuitem").setAttribute("disabled","false");
			return true;
		}
	}

	var tn = fe.tagName;
	var type = fe.getAttribute("type");
	if (type) type = type.toLowerCase();
	if (tn=="INPUT") {
		if (type=="password")
			{ tipSetScope(IS_PASSWORD, false); return true; }
		else if (type=="file")
			{ tipSetScope(IS_FILE_FULLFILEPATH, false); return true; }
		else if (type=="text" || type==null)
		{
			// it might be the anonymous child of a file input
			if (fe.parentNode.tagName == "INPUT")
			{
				var pt = fe.parentNode.type;
				if (pt) pt = pt.toUpperCase();
				if (pt=="FILE")
				{
					tipSetScope(IS_FILE_FULLFILEPATH, false); 
					return true;
				}
			}
		}
	}

	if (!tipScopeOn) { tipSetScope(IS_DEFAULT, false); return true; }

	// at this point we're done with special cases, lets try guessing scopes
	if ((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT")) 
	{
		var desc = tipElementDescriptor(fe);
		tipLastDesc=desc; //debug
		var i, re, noScopeYet=true;
		
		for (i=0; i < tipMatches.length; i++) 
		{
			if (desc.search(tipMatches[i].pattern) != -1) {
				if (noScopeYet) { 
					tipSetScope(tipMatches[i].code,false); 
					noScopeYet = false; 
				} else { 
					tipSetScope(tipMatches[i].code,true); 
				}
			}
		}
	}
	if (noScopeYet) tipSetScope(IS_DEFAULT, false);
	return true;
} 

function tipSetScope(s, add) 
{
	var bx = document.getElementById("geckotip-panel-label");
	var tipBundle = document.getElementById("bundle_geckotip");
	
	if (add) {
		geckotip.addScope(s);
		tipCurrentScopes = tipCurrentScopes + "/" + tipBundle.getString("tipScope" + s);
	} else {
		geckotip.setScope(s);
		tipCurrentScopes = tipBundle.getString("tipScope" + s);
	}
	bx.value = tipCurrentScopes;
	if (!tipScopeOn) bx.value = "(" + bx.value + ")";
}

function tipDebug()
{
	geckotip.toggleDebug();
}


function tipFlashXUL()
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return; 
	if (x.tagName == "html:input") {
		x.setSelectionRange(x.selectionEnd,x.selectionEnd);
	}
	return true;
}

function tipSendEnter() 
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return;
	var ev = document.createEvent("KeyEvents");
	ev.initKeyEvent("keypress", true, true, window, false, false, false, false, 13, 13);
	x.dispatchEvent(ev); 
}

window.addEventListener("blur",tipBlur,true);
window.addEventListener("focus",tipFocus,true);
window.addEventListener("dblclick",tipDebug,true);  //DEBUG
window.addEventListener("input",tipFlashXUL,false);  // necessary to fix Firefox caret tracking bug in XUL textboxes
